﻿using System.IO;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace WebAPI_Arquivos.Controllers
{
    public class ArquivosController : ApiController
    {
        string arquivo_Pdf = @"C:\Dados\PDF\teste.pdf";
        string arquivo_xls = @"C:\Dados\XLS\teste.xls";
        string arquivo_doc = @"C:\Dados\DOC\teste.docx";
        string arquivo_zip = @"C:\Dados\ZIP\teste.zip";

        [HttpGet]
        [ActionName("BaixarArquivo")]
        public IHttpActionResult BaixarArquivo(string formato)
        {
            string reqArquivo = formato.ToLower() == "pdf" ? arquivo_Pdf : (formato.ToLower() == "xls" ? arquivo_xls : (formato.ToLower() == "doc" ? arquivo_doc : arquivo_zip));
            string arquivoNome = "teste." + formato.ToLower();

            //converte arquivos em um array de bytes
            var dataBytes = File.ReadAllBytes(reqArquivo);
            //adiciona bytes ao memory stream   
            var dataStream = new MemoryStream(dataBytes);
            return new arquivoResult(dataStream, Request, arquivoNome);
        }
    }

    public class arquivoResult : IHttpActionResult
    {
        MemoryStream arquivoStuff;
        string nomeDoArquivo;
        HttpRequestMessage httpRequestMessage;
        HttpResponseMessage httpResponseMessage;
        public arquivoResult(MemoryStream data, HttpRequestMessage request, string filename)
        {
            arquivoStuff = data;
            httpRequestMessage = request;
            nomeDoArquivo = filename;
        }
        public System.Threading.Tasks.Task<HttpResponseMessage> ExecuteAsync(System.Threading.CancellationToken cancellationToken)
        {
            httpResponseMessage = httpRequestMessage.CreateResponse(HttpStatusCode.OK);
            httpResponseMessage.Content = new StreamContent(arquivoStuff);
            httpResponseMessage.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
            httpResponseMessage.Content.Headers.ContentDisposition.FileName = nomeDoArquivo;
            httpResponseMessage.Content.Headers.ContentType = new System.Net.Http.Headers.MediaTypeHeaderValue("application/octet-stream");

            return System.Threading.Tasks.Task.FromResult(httpResponseMessage);
        }
    }
}
